#revert to working version 3.22.26 for now

# Define if you want to build the sane backend (default)
%define sane_backend		1
%{?_with_sane:			%global sane_backend 1}
%{?_without_sane:		%global sane_backend 0}

%define hpip_major		0
%define hpip_libname		%mklibname hpip %{hpip_major}

%define sane_hpaio_major	1
%define sane_hpaio_libname	%mklibname sane-hpaio %{sane_hpaio_major}

# Suppress automatically generated Requires for devel packages
%global __requires_exclude	devel\\\(.*\\\)

# we don't want to provide private python extension libs
%global __provides_exclude	%{python3_sitearch}/.*\\.so$

#define extraversion -RC1
%define extraversion		%nil

%global _cups_serverbin /usr/lib/cups
%global _Cups_filterdir /usr/lib/cups/filter

Summary:	HP printer/all-in-one driver infrastructure
Name:		hplip
Version:	3.23.8
Release:	%mkrel 6
License:	GPLv2+ and MIT
Group:		System/Printing
Url:		https://developers.hp.com/hp-linux-imaging-and-printing
Source:		http://downloads.sourceforge.net/sourceforge/hplip/%{name}-%{version}%{extraversion}.tar.xz
Source1:	hpcups-update-ppds.sh
Source2:	copy-deviceids.py
Source3:	hp-sendfax.desktop

Patch1:		hplip-3.15.11-mga-automake-fix-subdir-objects.patch
Patch2:		hplip-apply-udev-rules-on-action-change.patch
Patch4:		hplip-3.18.3-hp_ipp.patch
Patch5:		hplip-3.15.11-mga-plasma-delay-startup.patch

Patch101:	hplip-pstotiff-is-rubbish.patch
Patch102:	hplip-strstr-const.patch
Patch104:	hplip-no-asm.patch
Patch107:	hplip-udev-rules.patch
Patch108:	hplip-retry-open.patch
Patch109:	hplip-snmp-quirks.patch

Patch111:	hplip-hpijs-marker-supply.patch
Patch112:	hplip-clear-old-state-reasons.patch
Patch113:	hplip-colorlaserjet-mfp-m278-m281.patch
Patch114:	hplip-hpcups-sigpipe.patch
Patch115:	hplip-logdir.patch
Patch116:	hplip-bad-low-ink-warning.patch
Patch117:	hplip-ui-optional.patch
Patch121:	hplip-ppd-ImageableArea.patch
# error with new gcc, already reported in upstream as
# https://bugs.launchpad.net/hplip/+bug/1836735
Patch122:	hplip-fix-Wreturn-type-warning.patch
# upstream check for python clears OS build system CFLAGS
# https://bugs.launchpad.net/hplip/+bug/1879445
Patch123:	hplip-configure-python.patch


Patch201:	01_rss.dpatch
Patch203:	14_charsign_fixes.dpatch
Patch204:	hplip-3.15.11-mga-85_rebuild_python_ui.dpatch
Patch205:	0025-Remove-all-ImageProcessor-functionality-which-is-clo.patch

Patch207:	hplip-pjl-duplex-binding.patch
Patch219:	try_libhpmud.so.0.dpatch
Patch220:	add-lidil-two-cartridge-modes.dpatch
Patch222:	hp-plugin-download-fix.dpatch
Patch223:	install-check-plugin.diff
Patch224:	pcardext-python3-workaround-upstream.dpatch
Patch225:	hpfax-bug-function-used-before-importing-log.dpatch
Patch226:	hp-systray-make-menu-title-visible-in-sni-qt-indicator.dpatch
Patch227:	hp-systray-make-menu-appear-in-sni-qt-indicator-with-kde.dpatch
Patch228:	hpaio-option-duplex.diff
Patch229:	ui-patch-upstream-like.dpatch

Patch301:	hplip-mga21945-disable-hp-upgrade-log-msg.patch
Patch302:	hplip-3.17.10-mga-set-qt5-in-HelpAboutDialog.patch
Patch303:	hplip-3.18.7-mga-fix-hp-systray-desktop-file.patch
Patch304:	hplip-3.18.12-mga-fix-hp-uiscan-desktop-file.patch

%if %{sane_backend}
BuildRequires:	pkgconfig(sane-backends)
BuildRequires:	xsane
%endif
BuildRequires:	openssl-devel
BuildRequires:	python3
BuildRequires:	python3-qt5-devel
BuildRequires:	pkgconfig(avahi-client)
BuildRequires:	pkgconfig(avahi-core)
BuildRequires:	pkgconfig(python3)
BuildRequires:	net-snmp-devel
BuildRequires:	pkgconfig(libusb-1.0)
BuildRequires:	imagemagick
BuildRequires:	autoconf
BuildRequires:	libcups-devel
BuildRequires:	pkgconfig(libjpeg)
BuildRequires:	desktop-file-utils
BuildRequires:	pkgconfig(dbus-1)
BuildRequires:	pkgconfig(udev)
BuildRequires:	polkit
BuildRequires:	pkgconfig(libgphoto2)
BuildRequires:	libv4l-devel
# Make sure we get postscriptdriver tags:
BuildRequires:	cups
BuildRequires:	python3-cups

Requires:	cups
# For dynamic ppd generation.
Requires:	cups-filters
Requires:	net-snmp-mibs
Requires:	python3-reportlab
Requires:	python3-dbus
Requires:	polkit-agent
Requires:	python3-gobject3
Requires:	python3-pillow
Requires:	python3-distro
Requires:	sane-backends-hpaio
Requires:	wget
Requires:	acl
Requires:	usbutils
Requires(post,postun):	%{__service}

BuildRoot:	%defaultbuildroot

Provides:	%{name} = %{version}-%{release}
Obsoletes:	%{name} < %{version}-%{release}

Provides:	hplip-hpijs = %{version}-%{release}
Obsoletes:	hplip-hpijs < %{version}-%{release}
#----------------------------------------------------
%description
The Hewlett-Packard Linux Imaging and Printing Project provides
drivers for HP printers and multi-function peripherals.

%package common
Summary:	Files needed by the HPLIP printer and scanner drivers
Group:		System/Printing
License:	GPLv2+
Requires:	udev

%description common
Files needed by the HPLIP printer and scanner drivers.

%package libs
Summary:	HPLIP libraries
Group:		System/Printing
License:	GPLv2+ and MIT
Requires:	%{name}-common = %{version}-%{release}
Requires:	python3

%description libs
Libraries needed by HPLIP.

%package  gui
Summary:	HPLIP graphical tools
Group:		System/Printing
License:	BSD
Requires:	%{name} = %{version}-%{release}
Requires:	python3-gobject3
Requires:	python3-qt5
Requires:  python3-pyqt5-sip

%description gui
HPLIP graphical tools.

%package -n libsane-hpaio
Summary:	SANE driver for scanners in HP's multi-function devices
Group:		System/Printing
License:	GPLv2+
Requires:	%{name}-libs = %{version}-%{release}
Requires:	sane-backends
Requires(preun): %{__service}
Provides:	sane-backends-hpaio = %{version}-%{release}

%description -n libsane-hpaio
SANE driver for scanners in HP's multi-function devices (from HPOJ).

%package devel
Summary:	HPLIP development libraries
Group:		System/Printing
License:	GPLv2+ and MIT
Requires:	%{name}-common = %{version}-%{release}
Requires:	python3
Provides:	libsane-hpaio-devel = %{version}-%{release}

%description devel
Development Libraries needed by HPLIP.

%package systray
Summary:	HPLIP systray applet
Group:		System/Printing
License:	GPLv2+ and MIT
Requires:	%{name}-common = %{version}-%{release}
Requires:	%{name}-gui = %{version}-%{release}


%description systray
HPLIP systray applet that starts at login. 

%package	hpijs
Summary:	HPs printer driver IJS plug-in for GhostScript
Group:		System/Printing
Requires:	ghostscript
Provides:	hpijs
Requires:	%{name} = %{version}-%{release}

%description	hpijs
HPs printer driver IJS plug-in for GhostScript. This driver gives full
printing support for nearly all non-PostScript inkjet and laser
printers made by HP.

%package	hpijs-ppds
Summary:	PPD files for the HPIJS printer driver
Group:		System/Printing
Requires:	cups-filters
Requires:	hplip-hpijs
Requires:	%{name} = %{version}-%{release}

%description	hpijs-ppds
PPD files to use the HPIJS printer driver with foomatic-rip and a
printer spooler like CUPS, LPRng, PDQ, ...


%package	doc
Summary:	Documentation for HPLIP
Group:		Documentation
Requires:	%{name} = %{version}-%{release}

%description	doc
This package contains documentation for the HPLIP driver.

This is the HP driver package to supply Linux support for most
Hewlett-Packard DeskJet, LaserJet, PSC, OfficeJet, and PhotoSmart
printers and all-in-one peripherals (also known as Multi-Function
Peripherals or MFPs), which can print, scan, copy, fax, and/or access
flash memory cards.

%prep
rm -rf $RPM_BUILD_DIR/%{name}-%{version}%{extraversion}
%setup -q -n %{name}-%{version}%{extraversion}

%patch1 -p1 -b .automake-subdir-objects
%patch2 -p1 -b .udev-rules-on-action-change
%patch4 -p1 -b .hp_ipp
%patch101 -p1 -b .pstotiff-is-rubbish
%patch102 -p1 -b .strstr-const
%patch104 -p1 -b .no-asm
%patch107 -p1 -b .udev-rules
%patch108 -p1 -b .retry-open
%patch109 -p1 -b .snmp-quirks
%patch111 -p1 -b .hpijs-marker-supply
%patch112 -p1 -b .clear-old-state-reasons
#patch113 -p1 -b .colorlaserjet-mfp-m278-m281
%patch114 -p1 -b .hpcups-sigpipe
%patch115 -p1 -b .logdir
%patch116 -p1 -b .bad-low-ink-warning
%patch117 -p1 -b .ui-optional

for ppd_file in $(grep '^diff' %{PATCH121} | cut -d " " -f 4);
do
  gunzip ${ppd_file#*/}.gz
done
%patch121 -p1 -b .ImageableArea
for ppd_file in $(grep '^diff' %{PATCH121} | cut -d " " -f 4);
do
  gzip -n ${ppd_file#*/}
done

# Don't run 'chgrp lp /var/log/hp' in makefile (removes all lines with "chgrp")
sed -i '/chgrp/d' Makefile.am

sed -i.duplex-constraints \
    -e 's,\(UIConstraints.* \*Duplex\),//\1,' \
    prnt/drv/hpcups.drv.in

%patch122 -p1 -b .Wreturn-fix
%patch123 -p1 -b .configure-python

%patch201 -p1 -b .01_rss
%patch203 -p1 -b .14_charsign
%patch204 -p1 -b .85_rebuild_python_ui
%patch205 -p1 -b .0025_ImageProcessor
%patch207 -p1 -b .hplip-pjl-duplex-binding
#%%patch215 -p1 -b .simple-scan-as-default
%patch219 -p1 -b .try_libhpmud.so.0
%patch220 -p1 -b .add-lidil-two-cartridge-modes
%patch222 -p1 -b .plugin-download
%patch223 -p1 -b .install-check-plugin
#%patch224 -p1 -b .pcardext-python3-workaround
%patch225 -p1 -b .hpfax-bug-function-used-before-importing-log
%patch226 -p1 -b .hp-systray-make-menu-title-visible-in-sni-qt-indicator
%patch227 -p1 -b .hp-systray-make-menu-appear-in-sni-qt-indicator-with-kde
%patch228 -p1 -b .hpaio-option-duplex
%patch229 -p1 -b .ui-patch-upstream-like
%patch301 -p1 -b .remove-hp-upgrade-calls
%patch302 -p1 -b .set_qt5
%patch303 -p1 -b .systray
%patch304 -p1 -b .uiscan

%if 0
# Use filter foomatic-rip instead of foomatic-rip-hplip (fix from Mandriva)
for PPDGZ in ppd/hpijs/*.ppd.gz
do
mv -T "$PPDGZ" "$PPDGZ.old"
zcat "$PPDGZ.old" | sed -e 's/foomatic-rip-hplip/foomatic-rip/' | gzip -c > "$PPDGZ"
rm -f "$PPDGZ.old"
done
%endif

# Make all files in the source user-writable
chmod -R u+w .

# Change shebang /usr/bin/env python -> /usr/bin/python3
find -name '*.py' -print0 | xargs -0 sed -i \
    -e 's,^#!/usr/bin/env python,#!%{__python3},' \
    -e 's,^#!/usr/bin/python$,#!%{__python3},'
sed -i -e 's,^#!/usr/bin/env python,#!%{__python3},' \
    prnt/filters/hpps \
    fax/filters/pstotiff

%build
%serverbuild
# create required files as placeholder, otherwise autoreconf fails
touch NEWS README AUTHORS ChangeLog
#needed by patches 204 and 205
autoreconf -ifv


%if !%{sane_backend}
WITHOUT_SANE="--without-sane"
%endif
%configure2_5x $WITHOUT_SANE \
	--enable-scan-build \
	--enable-gui-build \
	--enable-fax-build \
 	--disable-foomatic-rip-hplip-install \
 	--disable-imageProcessor-build \
	--enable-pp-build \
	--enable-hpijs-install \
	--enable-qt5 --disable-qt4 \
	--enable-hpcups-install \
	--enable-cups-drv-install \
	--enable-cups-ppd-install \
	--enable-policykit \
	--with-mimedir=%{_datadir}/cups/mime \
	PYTHON=%{__python3}

# deprecated
# 	--disable-foomatic-rip-hplip-install \
#	--enable-pp-build \
#	--enable-hpijs-install \


sed -i 's|^hardcode_libdir_flag_spec=.*|hardcode_libdir_flag_spec=""|g' libtool
sed -i 's|^runpath_var=LD_RUN_PATH|runpath_var=DIE_RPATH_DIE|g' libtool

%make_build

%install
mkdir -p %{buildroot}%{_bindir}
mkdir -p %{buildroot}%{_includedir}
mkdir -p %{buildroot}%{_initrddir}
mkdir -p %{buildroot}%{_sysconfdir}/hp

%make_install

# Install files which the "make install" missed to install
install -m 644 ip/hpip.h %{buildroot}%{_includedir}
install -m 644 ip/xform.h %{buildroot}%{_includedir}

# Remove static libraries of SANE driver
rm -f %{buildroot}%{_libdir}/sane/libsane-hpaio*.so
rm -f %{buildroot}%{_libdir}/sane/libsane-hpaio*.la
rm -f %{buildroot}%{_sysconfdir}/sane.d/dll.conf

# Remove other unneeded/unwanted files
rm -f %{buildroot}%{_datadir}/hplip/uninstall.*
rm -f %{buildroot}%{_bindir}/hp-uninstall
# remove all upgrade-dialog files, also related to CVE-2013-6427
# previously we only removed the upgrade binary, but missed some upgrade dialog files
rm -f %{buildroot}%{_datadir}/hplip/upgrade*
rm -f %{buildroot}%{_bindir}/hp-upgrade
rm -f %{buildroot}%{_bindir}/hp-config_usb_printer
rm -f %{buildroot}%{_unitdir}/hplip-printer@.service
rm -f %{buildroot}%{_datadir}/hplip/config_usb_printer.*

mkdir -p %{buildroot}%{_datadir}/applications
desktop-file-install --vendor='' \
	--dir=%{buildroot}%{_datadir}/applications \
	--remove-category='Application' \
	--remove-category='Utility' \
	--add-category='System' \
	--add-category='Settings' \
	--add-category='Printing' \
	--add-category='Qt' \
	--add-category='HardwareSettings' \
  	--add-category='X-MandrivaLinux-System-Configuration-Printing;' \
  	--remove-key='Encoding' \
	--remove-key='Version' \
  	%{buildroot}%{_datadir}/applications/hplip.desktop

%__install -m644 %{SOURCE3} %{buildroot}%{_desktopdir}/hp-sendfax.desktop

# we not need systemd junk
## tmpfiles.d for folders on transient media
##%{__install} -D -p -m 0644 %{SOURCE2} %{buildroot}%{_tmpfilesdir}/%{name}.conf

# switched to udev, no need for hal information
rm -rf  %{buildroot}%{_datadir}/hal/fdi

%__mkdir_p %{buildroot}%{_sysconfdir}/sane.d/dll.d
echo hpaio > %{buildroot}%{_sysconfdir}/sane.d/dll.d/hpaio

%__mkdir_p %{buildroot}/run/hplip

%__install -Dm 644 ip/hpip.h %{buildroot}%{_includedir}/hpip.h
%__install -m 644 ip/xform.h %{buildroot}%{_includedir}

find %{buildroot} -type f -name '*.la' -delete

# Regenerate hpcups PPDs on upgrade if necessary (bug #579355).
install -p -m755 %{SOURCE1} %{buildroot}%{_bindir}/hpcups-update-ppds

# Fedora pstotiff
rm -f %{buildroot}%{_sysconfdir}/cups/pstotiff.types
rm -f %{buildroot}%{_datadir}/cups/mime/pstotiff.types
rm -f %{buildroot}%{_datadir}/hplip/fax/pstotiff*
rm -f %{buildroot}%{_prefix}/lib/cups/filter/hpcac

# pclos removes
%__rm -f \
  %{buildroot}%{_sysconfdir}/sane.d/dll.conf \
  %{buildroot}%{_bindir}/{hp-doctor,hp-logcapture,hp-uninstall,hp-upgrade} \
  %{buildroot}/usr/lib/systemd/system/hplip-printer@.service \
  %{buildroot}%{_datadir}/hplip/{doctor.py,logcapture.py,uninstall.py,upgrade.py} \
  %{buildroot}%{_datadir}/cups/mime/pstotiff.types \
  %{buildroot}%{_datadir}/hplip/fax/pstotiff*


# bork?
install -d %{buildroot}%{_sysconfdir}/cups
cp -p %{buildroot}%{_datadir}/cups/mime/pstotiff.convs %{buildroot}%{_sysconfdir}/cups/pstotiff.convs

# (cg) Create post consolehelper compatibility links
mkdir -p %{buildroot}%{_sbindir}
ln -sf %{_bindir}/hp-setup %{buildroot}%{_sbindir}

# Make sure pyc files are generated, otherwise we can get
# difficult to debug problems
pushd %{buildroot}%{_datadir}/%{name}
python -m compileall .
popd

# create empty /var/lip/hp/hplip.state to fix hp-plugin installation (mga#5395)
mkdir -p %{buildroot}%{_localstatedir}/lib/hp/
touch %{buildroot}%{_localstatedir}/lib/hp/hplip.state

# create empty log directory so that it can be owned
mkdir -p %{buildroot}%{_localstatedir}/log/hp/tmp


%files
%defattr(-,root,root)
%config(noreplace) %{_sysconfdir}/cups/pstotiff.convs
%config(noreplace) %{_sysconfdir}/dbus-1/system.d/com.hp.hplip.conf
/lib/udev/rules.d/56-hpmud.rules
%dir %attr(0775,root,lp) /run/hplip
%{_bindir}/hpijs
%{_bindir}/hpcups-update-ppds
%{_bindir}/hp-*
%{_sbindir}/hp-setup
%attr(0755,root,root) %{_cups_serverbin}/backend/hp*
%{_cups_serverbin}/filter/hp*
%{_cups_serverbin}/filter/pstotiff
%{_datadir}/hplip
%{_datadir}/cups/drv/hp/hpcups.drv

%{_datadir}/cups/mime/pstotiff.convs
%{_datadir}/dbus-1/system-services/com.hp.hplip.service
%{_datadir}/polkit-1/actions/com.hp.hplip.policy
%{_datadir}/ppd
%{_localstatedir}/lib/hp
%dir %attr(0774,root,lp) %{_logdir}/hp
%dir %attr(1774,root,lp) %{_logdir}/hp/tmp
%exclude %{_bindir}/hp-check
%exclude %{_bindir}/hp-print
%exclude %{_bindir}/hp-systray
%exclude %{_bindir}/hp-toolbox
%exclude %{_datadir}/hplip/check.py*
%exclude %{_datadir}/hplip/print.py*
%exclude %{_datadir}/hplip/systray.py*
%exclude %{_datadir}/hplip/toolbox.py*
%exclude %{_datadir}/hplip/data/images


%files common
%defattr(-,root,root)
%dir %{_sysconfdir}/hp
%config(noreplace) %{_sysconfdir}/hp/hplip.conf
%dir %{_datadir}/hplip
%dir %{_datadir}/hplip/data
%{_datadir}/hplip/data/models

%files libs
%defattr(-,root,root)
%{_libdir}/libhpip*.so.*
%{_libdir}/libhpmud.so.*
%{_libdir}/libhpdiscovery.so.*
%{python3_sitearch}/*.so*

%files gui
%defattr(-,root,root)
%{_bindir}/hp-check
%{_bindir}/hp-print
%{_bindir}/hp-toolbox
%{_desktopdir}/*.desktop
%{_datadir}/hplip/check.py*
%{_datadir}/hplip/print.py*
%{_datadir}/hplip/systray.py*
%{_datadir}/hplip/toolbox.py*
%{_datadir}/hplip/data/images
%{_datadir}/hplip/ui5
%{_datadir}/hplip/uiscan.py*

%files hpijs
%{_bindir}/hpijs
# Needed for both printing and fax PPDs. They all need HPIJS, therefore
# the link is here
%dir %{_datadir}/ppd
%dir %{_datadir}/ppd/HP
%{_bindir}/hpcups-update-ppds

%files hpijs-ppds
%{_datadir}/ppd/HP/apollo*.ppd*
%{_datadir}/ppd/HP/hp-*.ppd*

%files -n libsane-hpaio
%defattr(-,root,root)
%config(noreplace) %{_sysconfdir}/sane.d/dll.d/hpaio
%{_libdir}/sane/libsane-hpaio*.so.*

%files devel
%defattr(-,root,root)
%{_libdir}/libhp*.so
%{_includedir}/hpip.h
%{_includedir}/xform.h

%files systray
%defattr(-,root,root)
%{_sysconfdir}/xdg/autostart/hplip-systray.desktop
%{_bindir}/hp-systray

%files doc
%{_datadir}/doc

%post
#sneak a fix in for cups
/bin/cp /usr/sbin/enable /usr/bin/enable &>/dev/null ||:

%{_bindir}/hpcups-update-ppds &>/dev/null ||:

if [ -f /etc/init.d/cups ]; then
        %__service cups condrestart || :
fi

%postun
if [ -f /etc/init.d/cups ]; then
        %__service cups condrestart || :
fi

%post common
/sbin/udevadm trigger --subsystem-match=usb --attr-match=idVendor=03f0
/sbin/udevadm settle --timeout=15

%preun -n libsane-hpaio
if [ -f /etc/init.d/cups ]; then
        %__service cups condrestart || :
fi


%changelog
* Fri Nov 17 2023 tex - 3.23.8-6pclos2023
- move python3-pyqt5-sip dep to gui pkg

* Tue Oct 17 2023 tex - 3.23.8-5pclos2023
- revert to working version 3.22.26 for now

* Sun Aug 21 2022 TerryN <terryn94 at gmail.com> - 3.22.6-1pclos2022
- update

* Sun Aug 21 2022 TerryN <terryn94 at gmail.com> - 3.20.9-6pclos2022
- Add patch 305 for PY_SSIZE_T_CLEAN macro error

* Mon Aug 08 2022 TerryN <terryn94 at gmail.com> - 3.20.9-5pclos2022
- remove bogus requires for python3-sip

* Wed Aug 03 2022 TerryN <terryn94 at gmail.com> 3.20.9-4pclos2022
- add requires for python3-distro

* Sun Mar 20 2022 TerryN <terryn94 at gmail.com> 3.20.9-3pclos2022
- rebuild for python 3.10

* Tue Oct 20 2020 tex - 3.20.0-2pclos2020
- add more requires on hplip
- sneak a fix in for cups enable

* Fri Aug 14 2020 onkelho <oh.quait at gmail.com> - 3.20.9-1pclos2020
- new version release

* Fri Jan 03 2020 tex - 3.19.3-4pclos2020
- fix udev rules location

* Sun Apr 14 2019 tex 3.19.3-3pclos2019
- change to python3-qt5
